package solutions;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

public enum WeekdayV2 {
	MON("hu", "h", "en", "mo"),
	TUE("en", "tu", "hu", "ke"),
	WED("alien", "dghkasjgfhdksjzgfhdsjkfhg"),
	THU(Map.of("hu", "cst", "en", "thu")),
	NONAME
//	Map<Integer, String> of = Map.of(1, "fdhsfajf", 3451, "dsg fds");
	;

	Map<String, String> names = new HashMap<>();

	// csak pros db par
	WeekdayV2(String... names) {
		for (int i = 0; i < names.length; i+=2) {
			this.names.put(names[i], names[i+1]);
		}
	}

	WeekdayV2(Map<String, String> names) {
		this.names = new HashMap<>(names);
//		this.names = names;
	}
	
//	public String getName(String langCode) {
//		return names.get(langCode);
//	}

	public Optional<String> getName(String langCode) {
		var retval = names.get(langCode);
		return retval == null ? Optional.empty() : Optional.of(retval);
	}

	public WeekdayV2 nextDay() {
		var weekdays = WeekdayV2.values();
		return weekdays[(this.ordinal() + 1) % weekdays.length];
	}
}
