import static java.lang.Integer.parseInt;
import static java.lang.System.out;
import static java.util.function.Function.identity;

import java.util.function.BiFunction;
import java.util.function.BiPredicate;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.IntBinaryOperator;
import java.util.function.IntFunction;
import java.util.function.IntUnaryOperator;
import java.util.function.Predicate;
import java.util.function.Supplier;

public class Lambdas {
	public static void main(String[] args) {
		// () -> ()
		// () -> T
		// T -> ()
		// T1 -> T2
		// (T1, T2) -> T3
		// int -> T
		// int -> int
		// T -> boolean
		// (T1, T2) -> boolean
		// int -> boolean

		Runnable r = () -> out.println("Hello");
		r.run();

		Supplier<Supplier<Double>> suppSupp = () -> () -> 1.0;

		Consumer<Integer> printer = n -> {
			System.out.println(n);
			System.out.println(n);
			System.out.println(n);
		};
		printer.accept(123);

		Consumer<Integer> printer2 = out::println;
		printer2.accept(999);

		Function<Integer, String> f = n -> n == 1 ? "egy" : "nem egy";
		Function<Integer, String> fDetailed = (Integer n) -> n == 1 ? "egy" : "nem egy";
		System.out.println(f.apply(1));
		System.out.println(f.apply(2));

		IntFunction<String> f2 = n -> n == 1 ? "egy" : "nem egy";
		IntFunction<String> f2Detailed = (int n) -> n == 1 ? "egy" : "nem egy";

		IntFunction<Integer> f3 = n -> n;
		IntUnaryOperator f4 = n -> n;
		Function<Integer, Integer> f5 = Function.identity();
		Function<Integer, Integer> f5b = identity();
		System.out.println(f4.applyAsInt(123));

		IntBinaryOperator biop = (n1, n2) -> n1 + n2;
		BiFunction<Integer, String, Boolean>
			fun = (n, s) -> Integer.parseInt(s) < n;

		Predicate<String> len5 = s -> s.length() < 5;
		BiPredicate<Integer, String>
			pred2 = (n, s) -> parseInt(s) < n;
			
		char c = '0';
		Character c2 = c;
		char c3 = c2;
		Character evil = null;
		char c5 = evil;
		
		
		Supplier<Double> supp = () -> {
			return 1.234;
		};

		Supplier<Double> supp2 = () -> 1.234;

		System.out.println(supp2.get());
		System.out.println(supp2.get());
		System.out.println(supp2.get());
		System.out.println(supp2.get());
		System.out.println(supp2.get());

		final Double betterSupplier = 1.234;
		MySupplier<Double> mySupp = () -> 1.234;
		MySupplier<Double> mySupp2 = new MySupplierImpl();
		MySupplier<Double> mySupp3 = new MySupplier<Double>() {
			@Override
			public Double f() {
				return 1.234;
			}
		};

		System.out.println(mySupp.f());
		System.out.println(mySupp2.f());
		System.out.println(mySupp3.f());

		System.out.println(mySupp.getClass().getName());
		System.out.println(mySupp2.getClass().getName());
		System.out.println(mySupp3.getClass().getName());

		// Lambdas.main(...).new Supplier() {...}
		var mySupp4 = new Supplier<Integer>() {
			int counter = 0;

			@Override
			public Integer get() {
				return ++counter;
			}
			
			public int f() {
				return 123;
			}
		};

		System.out.println(mySupp4.f());
		System.out.println(mySupp4.get());
		System.out.println(mySupp4.get());
		System.out.println(mySupp4.get());
		System.out.println(mySupp4.get());
		System.out.println(mySupp4.get());

	
		Supplier<Supplier<Integer>> superSupp = () -> () -> 1;
		Supplier<Integer> supplier = superSupp.get();
		System.out.println(supplier.get());
		System.out.println(supplier.get());
		System.out.println(supplier.get());

	
		Supplier<Integer> supp5 = giveMeASupplier();
		System.out.println(supp5.get());
		System.out.println(supp5.get());
		System.out.println(supp5.get());

	}


	static int[] counter = {0};

	private static Supplier<Integer> giveMeASupplier() {
		// effectively final
//		int counter = 0;
//		return () -> ++counter;

//		int[] counter = {0};
//		return () -> ++counter[0];
		return () -> ++counter[0];
	}
}


@FunctionalInterface
interface MySupplier<T> {
	T f();
}

class MySupplierImpl implements MySupplier<Double> {

	@Override
	public Double f() {
		return 1.234;
	}
	
}


