import static java.util.Arrays.stream;
import static java.util.stream.Collectors.toList;
import static java.util.stream.IntStream.range;
import static java.util.stream.IntStream.rangeClosed;
import static java.util.stream.Stream.of;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.IntSummaryStatistics;
import java.util.List;
import java.util.OptionalInt;
import java.util.function.Function;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Streams {
	public static void main(String[] args) throws ClassNotFoundException, IOException {
		Stream<Integer> stream2 = of(1, 2, 3);
		Stream<Integer> stream = Stream.of(1, 2, 3);
		stream.forEach(i -> System.out.println(i));

		Stream.of(1, 2, 3)
			.forEach(System.out::println);

		IntStream.of(1, 2, 3)
			.forEach(System.out::println);
		
		long count = IntStream.of(1, 2, 3)
			.count();

		int sum = IntStream.of(1, 2, 3).sum();
		OptionalInt k = IntStream.of(1, 2, 3).max();
		OptionalInt noMax = IntStream.of().max();

		IntSummaryStatistics stats
			= IntStream.of(1, 2, 3).summaryStatistics();

		System.out.println(count);
		System.out.println(sum);
		System.out.println(k);
		System.out.println(noMax);
		System.out.println(stats);
		System.out.println(stats.getAverage());

		Arrays.stream(new int[] {1, 2, 3});
		stream(new int[] {1, 2, 3});

		IntStream.range(0, 10)
			.forEach(System.out::println);
		IntStream.rangeClosed(100, 110)
			.forEach(System.out::println);
		range(0, 10)
			.forEach(System.out::println);
		rangeClosed(100, 110)
			.forEach(System.out::println);

		System.out.println("---------------------");
		
		range(0, 10)
			.forEach(i -> {
				System.out.println(i);
				i += 3;
			});

		System.out.println("---------------------");

		for (int i = 0; i < 10; i++) {
			System.out.println(i);
			i += 3;
		}
		
		Supplier<Integer> supp7 = () -> 7;
		Stream.generate(supp7)
			.limit(7)
			.forEach(System.out::println);

		Stream.iterate(7, i -> i + 1)
			.limit(7)
			.forEach(System.out::println);

		// Throwable
		// 	- Error
		// 	- Exception
		// 		- RuntimeException
		try {
			Files.lines(Paths.get("src", "Streams.java"))
				.map(String::length)
//				.map(s -> s.length())
				.filter((Integer i) -> i > 0)
				.filter(i -> i < 30)
//				.mapToInt(Function.<Integer>identity())
				.mapToInt(i -> i)
				.forEach(System.out::println);

			var resultData = Files.lines(Paths.get("src", "Streams.java"))
				.map(String::length)
				.limit(10)
				.filter((Integer i) -> i > 0)
				.filter(i -> i < 30)
				.mapToInt(i -> i)
				.summaryStatistics();

			System.out.println(resultData);
			
			var resultData2 = Files.lines(Paths.get("src", "Streams.java"))
					.map(String::length)
					.filter((Integer i) -> i > 0)
					.filter(i -> i < 30)
					.limit(10)
					.mapToInt(i -> i)
					.summaryStatistics();
			
			System.out.println(resultData2);

			var hackData = new int[] { 0 };
			var resultData3 = Files.lines(Paths.get("src", "Streams.java"))
					.map(t -> {
						hackData[0] += t.length();
						return t.length();						
					})
					.filter((Integer i) -> i > 0)
					.filter(i -> i < 30)
					.limit(10)
					.mapToInt(i -> i + hackData[0])
					.summaryStatistics();

			System.out.println(resultData3);

			var resultData4 = Files.lines(Paths.get("src", "Streams.java"))
					.map(t -> {
						hackData[0] += t.length();
						return t.length();						
					})
					.filter((Integer i) -> i > 0)
					.filter(i -> i < 30)
					.limit(10)
					.mapToInt(i -> i + hackData[0])
					.summaryStatistics();
			
			System.out.println(resultData4);
			
//			new ArrayList<Integer>();
			
			IntStream.of(1,2,3)
				.mapToObj(i -> i + "")
				.forEach(System.out::println);
				;

			IntStream.of(1,2,3)
				.boxed()
				.forEach(System.out::println);
				;

			IntStream.of(1,2,3)
				.dropWhile(i -> i < 2);
			IntStream.of(1,2,3,1)
				.takeWhile(i -> i < 2);

			IntStream.of(1,2,3,1)
				.forEach(i -> {});

			List<Integer> list = Stream.of(1,2,3,1)
				.collect(Collectors.toList());
			List<Integer> list2 = Stream.of(1,2,3,1)
				.collect(toList());
			Object[] list3 = Stream.of(1,2,3,1)
				.toArray();
			Integer[] array2 = Stream.of(1,2,3,1)
				.toArray(Integer[]::new);
			Integer[] array3 = Stream.of(1,2,3,1)
				.toArray((int value) -> new Integer[value]);
			
			int[] array = IntStream.of(1,2,3,1)
				.toArray();
			
			List<Integer> myList0 = List.of();
			List<Integer> myList1 = List.of(1);
//			myList0.add(123);
			list.add(123);
		} catch (Exception e) {
			// TODO autogenerated
			System.err.println(e);
			e.printStackTrace();
			e.printStackTrace(System.err);
		}
	}

	@SuppressWarnings("unused")
	public static void main2(String[] args) throws ClassNotFoundException, IOException {
//		InputStream is;
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream("a.b"));
		
		// raw type
		ArrayList<Integer> ar;

		// type erasure
		@SuppressWarnings("unchecked")
		List<String> myStringFromSomeFile
			= (List<String>)ois.readObject();
	}
}
